// Copyright (C) 2005 Dirk Reusch
//
// This file is part of SUG3D
//
// SUG3D is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// SUG3D is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
// You should have received a copy of the GNU General Public License
// along with SUG3D; see the file COPYING.  If not, write to the Free
// Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// $Id: SUG_Setup.sci,v 1.1 2005/06/27 15:08:05 dirk Exp dirk $

function [x,y,typ]=SUG_Setup(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
    case 'plot' then //normal  position
    standard_draw(arg1)
    case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
    case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
    case 'getorigin' then
    [x,y]=standard_origin(arg1)
    case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs
    model=arg1.model   
    while %t do
      [ok,bg,obs,cl,exprs(1)]=getvalue('Setup of SUG_Setup block',..
        ['Background Color :';..
        'Observer Setup :';..
        'Clear (0=no,1=first,2=last) :'],..
        list('str',1,'vec',6,'vec',1),exprs(1))
      if ~ok then break, end
      graphics.exprs(1)=exprs(1);
      model.rpar(1)=bg
      model.rpar(2)=obs
      model.rpar(3)=cl
      x.graphics=graphics
      x.model=model
      break
    end
    while %t do
      scene=x_dialog('Scilab Script for Setup of 3D Scene:',exprs(2))
      if scene==[] then break, end
      graphics.exprs(2)=scene
      model.rpar(4)=scene
      x.graphics=graphics
      x.model=model
      break
    end
    case 'define' then
    bg="lightslategrey";
    obs=[10,0,0,0,0,0];
    cl=1;
    scene=['// define objects';'';'// create objects';'';'// place objects';''];
    model=scicos_model()
    model.sim=list('sug_setup_blk',3)
    model.rpar=list(bg,obs,cl,scene);
    model.blocktype='d'
    model.dstate=1
    model.dep_ut=[%f %f]
    exprs=list([bg;sci2exp(obs);sci2exp(cl)],scene);
    gr_i=['xstringb(orig(1),orig(2),''SUG Setup'',sz(1),sz(2),''fill'')']
    x=standard_define([2 2],model,exprs,gr_i)
  end
endfunction

