// Copyright (C) 2005 Dirk Reusch
//
// This file is part of SUG3D
//
// SUG3D is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// SUG3D is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
// You should have received a copy of the GNU General Public License
// along with SUG3D; see the file COPYING.  If not, write to the Free
// Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// $Id: sug_prism.sci,v 1.2 2005/06/27 15:08:05 dirk Exp dirk $
//
// FIXME: handle convexity of xyz?

function expr=sug_prism(xyz,dx,dy,dz,clr)
// optional named args: clr

  [r,c]=size(xyz);
  if c~=3 | r<3 then
    error('sug_prism: ""xyz"" is not a (n,3)-matrix, n>2.');
  end
  
  if exists('clr','local') then
    expr=msprintf('color %i %i %i; prism %i %g %g %g %s',..
                   name2rgb(clr),r,dx,dy,dz,strcat(string(xyz'),' '));
  else
    expr=msprintf('prism %i %g %g %g %s',..
                   r,dx,dx,dz,strcat(string(xyz'),' '));
  end

endfunction

